#!/usr/bin/python
# -*- coding: utf-8 -*-
from gi.repository import Gio
import gnomekeyring
import keyring
import imaplib


SCHEMA = 'org.gnome.shell.extensions.imap_notify'
gsettings = Gio.Settings.new(SCHEMA)

KEY = 'imap-user-name'
imap_user = gsettings.get_string(KEY)

KEY = 'imap-server'
imap_server = gsettings.get_string(KEY)

KEY = 'imap-password'
imap_password = gsettings.get_string(KEY)


keyring_login = gnomekeyring.get_default_keyring_sync()
keyring_is_locked = gnomekeyring.get_info_sync(keyring_login).get_is_locked()

if keyring_is_locked == False:
	# Save password in GNOME Keyring and delete password from dconf
	if imap_password != '*******':
		KEY = 'imap-password'
		gsettings.set_string(KEY, "*******")
		keyring.set_password("imap-notify-gnome-shell", 'imap-password', imap_password)
	#print "Get password from keyring"
	imap_password=keyring.get_password("imap-notify-gnome-shell", 'imap-password')
	if imap_password == None:
		keyring.set_password("imap-notify-gnome-shell", 'imap-password', "my_email_password")
    
	# Check email
	conn = imaplib.IMAP4_SSL(imap_server)
	try:
		(retcode, capabilities) = conn.login(imap_user, imap_password)
	except:
		#print sys.exc_info()[1]
		KEY = 'count'
		gsettings.set_string(KEY, '-2' )
		sys.exit(1)
    
	conn.select(readonly=1) # Select inbox or default namespace
	xread= conn.search(None, 'UnSeen')
	conn.close()
	xnbmail = len(xread[1][0].split())
	print "count is "+str(xnbmail)
    
	KEY = 'count'
	gsettings.set_string(KEY, str(xnbmail) )


else:
    # count=-1 means Keyring is locked
    KEY = 'count'
    gsettings.set_string(KEY, '-1' )
	
