const GObject    = imports.gi.GObject;
const Gdk        = imports.gi.Gdk;
const Gtk        = imports.gi.Gtk;
const Lang       = imports.lang;
const Utils      = imports.misc.extensionUtils.getCurrentExtension().imports.utils; 
const mySettings = Utils.getSettings();

const WA_IMAP_SERVER  = 'imap-server';
const WA_IMAP_USER    = 'imap-user-name';
const WA_PASSWORD     = 'imap-password';

function init() {
}

function changeServerName(object, text) {this.mySettings.set_string(WA_IMAP_SERVER, text.get_text());}
function changeUserName(object, text)   {this.mySettings.set_string(WA_IMAP_USER  , text.get_text());}
function changePassword(object, text)   {this.mySettings.set_string(WA_PASSWORD   , text.get_text());}

function buildPrefsWidget() {
	let frame = new Gtk.Box({ orientation: Gtk.Orientation.VERTICAL, border_width: 1 });
	let vbox1 = new Gtk.Box({ orientation: Gtk.Orientation.VERTICAL, margin_left:  1 });
	let label = new Gtk.Label({ label: "<b>IMAP Settings (Please, don't forget to press the Apply buttons)</b>", use_markup: true, xalign: 0 });

	// IMAP Server Name
	let hboxMenu1 = new Gtk.Box({orientation: Gtk.Orientation.HORIZONTAL});
	let labelMenu1 = new Gtk.Label({label: "IMAP Server Name ", xalign: 0});
	let valueMenu1 = new Gtk.Entry({ hexpand: true });
	valueMenu1.set_text(this.mySettings.get_string(WA_IMAP_SERVER));
	let buttonMenu1 = new Gtk.Button({ label: "Apply" });
	buttonMenu1.connect("clicked", Lang.bind(this, this.changeServerName  , valueMenu1 ));
	hboxMenu1.pack_start(labelMenu1, true, true, 0);
	hboxMenu1.add(valueMenu1);
	hboxMenu1.add(buttonMenu1);
    
	// IMAP User Name
	let hboxMenu2 = new Gtk.Box({orientation: Gtk.Orientation.HORIZONTAL});
	let labelMenu2 = new Gtk.Label({label: "IMAP User Name    ", xalign: 0});
	let valueMenu2 = new Gtk.Entry({ hexpand: true });
	valueMenu2.set_text(this.mySettings.get_string(WA_IMAP_USER));
	let buttonMenu2 = new Gtk.Button({ label: "Apply" });
	buttonMenu2.connect("clicked", Lang.bind(this, this.changeUserName  , valueMenu2 ));
	hboxMenu2.pack_start(labelMenu2, true, true, 0);
    hboxMenu2.add(valueMenu2);
	hboxMenu2.add(buttonMenu2);
    
	// IMAP Password
	let hboxMenu3 = new Gtk.Box({orientation: Gtk.Orientation.HORIZONTAL});
	let labelMenu3 = new Gtk.Label({label: "IMAP Password      ", xalign: 0});
	let valueMenu3 = new Gtk.Entry({ hexpand: true });
	valueMenu3.set_text(this.mySettings.get_string(WA_PASSWORD));
	let buttonMenu3 = new Gtk.Button({ label: "Apply" });
	buttonMenu3.connect("clicked", Lang.bind(this, this.changePassword  , valueMenu3 ));
	hboxMenu3.pack_start(labelMenu3, true, true, 0);
    hboxMenu3.add(valueMenu3);
	hboxMenu3.add(buttonMenu3);


	vbox1.add(hboxMenu1);
	vbox1.add(hboxMenu2);
	vbox1.add(hboxMenu3);

	frame.add(label);
	frame.add(vbox1);

	frame.show_all();
	return frame;
}



